Program FlagNew;
{$M 65520,0,0}
Uses
      pkPort,pkDoor,Misc,Door,TFile,Dos,Crt;

Const Sign='v.1.3';
      MaxFlag=65000;

Var
  FDir, FPath, PceDir, x                : String;
  LDate, LTime, Dummy                   : String[15];
  FileName                              : String[12];
  Found, Free, DupeCheck                : Boolean;
  CConf,FileListe                       : Integer;
  Count,Lt,ld,size                      : LongInt;
  Node                                  : Byte;
  ScanAll                               : Boolean;
  MaxConf,ConfCount                     : Byte;

Function fTime( f: String ) : LongInt;
Var fd    : Text;
    ft    : LongInt;
    t     : DateTime;
  Begin
    Assign(fd,f);
    {$I-}
    Reset(fd);
    {$I+}
    If IOResult<>0 then fTime:=0
    Else Begin
      GetFTime(fd,fT);
      UnPackTime(fT,T);
      With T Do Begin
        fTime:=StrInt(Zero(Hour)+Zero(min)+Zero(sec));
      End;
      Close(fd);
    End;
  End;

Function ReadConf(Conf : Byte): String;
Var Dir  : Byte;
    f    : String;
  Begin
    For dir:=1 to 9 do Begin
      If fExist(pkConf.ConfFiles[dir]+'DIR'+IntStr(dir)+'.TXT') Then Begin
        f:=pkConf.ConfFiles[dir]+'DIR'+IntStr(dir)+'.TXT';
        FileListe:=Dir;
      End;
    End;
    ReadConf:=f;
  End;

Procedure ReadDir;
Type  FlagDb2 = Record
              FileName   : String[12];
              ConfNr     : Integer;
              Size       : LongInt;
              FileListe  : Integer;
              Free       : Boolean;
      End;
Var
   MsgBuf         : Array[0..60000] of Char;
   FileList       : Text;
   d              : LongInt;
   ff             : File of FlagDb2;
   fr             : FlagDb2;
   c              : String[5];
   s              : String[33];
   GlobalCount,fd,ft : LongInt;
  Begin

    Found:=False;
    Assign(ff,PceDir+'FLAGDB.'+IntStr(Node));
    If not fExist(PceDir+'FLAGDB.'+IntStr(Node)) then Begin
      {$I-}
      ReWrite(ff);
      Close(ff);
      {$I+}
      If IOResult<>0 then Halt;
    End;
    {$I-}
    Reset(ff);
    {$I+}
    If IOResult<>0 then Halt;
    GlobalCount:=0;
    While not eof(ff) do Begin
      Read(ff,fr);
      Inc(GlobalCount);
    End;
    SetFileMode(ReadWriteMode,denyNone,inherit);
    AssignFile(FileList,FDir);
    {$I-}
    Reset(FileList);
    SetTextBuf(FileList,MsgBuf);
    {$I+}
    If IOResult<>0 then Halt;

    Count:=0;
    While not eof(FileList) do Begin
      ReadLn(FileList,x);
      If x[1]<>' ' then Begin
        Free:=False;
        d:=Pos(' P ',x);
        If d=0 then Begin
          d:=Pos(' F ',x);
          Free:=True;
        End;
        fd:=StrInt(Copy(x,d+3,6));

        Found:=False;
        If (fd>=ld) then Begin
          FileName:=x;
          d:=Pos(' ',FileName);
          If d<>0 then Delete(FileName,d,255);

          If (FTime(FPath+FileName)>=Lt) or (fd>=ld) then Begin
            size:=fSize(FPath+FileName);
            If size>0 then Begin
              If DupeCheck then Begin
                If GlobalCount<>0 then Begin
                  d:=0;
                  Reset(ff);
                  Repeat
                    Inc(d);
                    Read(ff,fr);
                  Until (d=GlobalCount) or (FileName=fr.FileName);
                End;
              End;
              If FileName<>fr.FileName then Begin
                While not eof(ff) do Read(ff,fr);
                Inc(Count);
                fr.FileName:=FileName;
                fr.ConfNr:=CConf;
                fr.FileListe:=FileListe;
                fr.Free:=free;
                fr.Size:=size;
                c:=IntStr(Count);
                for d:=1 to 5-Length(c) do c:=' '+c;
                s:='|54(|53'+IntStr(fr.size div 1024)+'k|54)|52 ';
                for d:=1 to 22-Length(s) do s:=s+' ';
                pkWriteLn('|51'+c+'|53: '+s+FileName);
                If (GlobalCount+Count<=MaxFlag) then Write(ff,fr)
              End;
            End;
          End;
        End;
      End;
    End;
    Close(FileList);
    Close(ff);
  End;

Begin
  DirectVideo:=False;
  pkAbout:=('           FlagNew ۲ '+sign+' (c) Nov. ''95 by MuHaDiB of AylA-BBs');
  pkStatusBar(9);

  PceDir:=GEnv('PCEXPRESS');
  Node:=StrInt(Right(ParamStr(1),1));
  If Right(ParamStr(2),1)<>'1' then DupeCheck:=False else DupeCheck:=True;

  If pkLocal then pkAnsi:=True;
  ScanAll:=True;
  Found:=False;

  pkLn;
  pkLn;
  pkWriteLn('|52FlagNew '+sign+'|51 by |54MuHaDiB');
  pkWriteLn('|53------------------------|51');
  pkln;
  LDate:=pkDrop.LastDate;
  LTime:=pkDrop.LastTime;
  lt:=StrInt(Copy(LTime,1,2)+Copy(LTime,4,2)+Copy(LTime,7,2));
  ld:=StrInt(Copy(LDate,7,2)+Copy(LDate,1,2)+Copy(LDate,4,2));
  pkWriteLn('|51Last Login Date |53: |52'+LDate);
  pkWriteLn('|51Last Login Time |53: |52'+LTime);
  pkLn;
  If Upper(EnterChar('|51Scan all conferences|54 (|53y|54/|53N|54)|53?|51 ','YN'))<>'Y' then ScanAll:=False;
  If ScanAll then MaxConf:=200 else MaxConf:=1;
  pkLn;
  For ConfCount:= 1 to MaxConf do Begin
    If ScanAll then Begin
      pkReadConf(ConfCount);
      CConf:=ConfCount;
    End Else Begin
      pkReadConf(pkDrop.CurrentConf);
      CConf:=pkDrop.CurrentConf;
    End;

    If pkDrop.ConfAccess[CConf] then Begin
      FDir:=ReadConf(CConf);
      FPath:=MDir(FDir);
      pkLn;
      pkWriteLn('|51Scanning FileDir of Conference '+IntStr(CConf));
      pkLn;
      ReadDir;
      pkLn;
      If Count>0 then pkWriteLn('|51Add files to Flagbase!')
                 else pkWriteLn('|51No new files in this Conference!');
      pkLn;
    End;
  End;

  pkWriteLn('|51This Version is |53registered|51 to |54'+pkconfig.bbssysop+' of '+pkConfig.bbsname);
  pkLn;
End.